#include <avr/io.h>
#include "Test1.h"
#include "Test2.h"

Object(Main) Main = {{1, 2}, {SomeFunc}};
#define This Main

int main (void)
{
	if (This.Functions.TestFunc1() == 0x02) PORTC = 1;
	
	PORTD = This.Globals.TestVar1;
	This.Globals.TestVar2 = 12;
	
	volatile Object(Main) NewMain = new Main;                // Create a new Main object, initalized to the current Main values
	volatile Object(Main) NewMain2;                          // Create a new Main object, no initalized
	
	NewMain.Globals.TestVar2 = 56;                           // Change the value of our new Main object
	NewMain.Functions.TestFunc1 = Test2.Functions.TestFunc1; // Re-map our new Main object to Test2's function
	
	Test2.Functions.TestFunc1();                             // Run a function in the Test2 object

	NewMain2.Functions.TestFunc1();                          // Object is uninitialized, therefore this pointer points to nothing
}

int SomeFunc (void)
{
	PORTB = 1;

	return 0;
}
